// MAKE SURE THAT THE STRING U INPUT INTO SERIAL IS ALL UPPERCASE
// OR THE CORE WILL PANIC. AND IT WON'T TELL U THAT IT DID thanks.

#include <Adafruit_NeoPixel.h>
#include "morse_code_table.h"

int Power = 11;
int PIN  = 12;
#define NUMPIXELS 1

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

const unsigned int dot_duration = 100;
const unsigned int dash_duration = 3 * dot_duration;
// total space duration is 7x dot_duration,
// there is a dash_duration blank between letters
const unsigned int space_duration = 4 * dot_duration;

void setup() {
  pixels.begin();
  pinMode(Power,OUTPUT);
  digitalWrite(Power, HIGH);
  Serial.begin(115200);
  while (!Serial);
}

void loop() {
  pixels.setPixelColor(0, pixels.Color(0, 255, 0));
  pixels.show();
  while(!Serial.available());
  String output = Serial.readString();
  Serial.println(output);
  for (int i = 0; i < output.length(); i++) {
    char letter = output.charAt(i);
    if (letter == ' ') {
      Serial.println("space");
      pixels.setPixelColor(0, pixels.Color(0, 0, 255));
      pixels.show();
      delay(space_duration);
      pixels.clear();
      pixels.show();
    } else {
      Serial.println(letter);
      output_morse_code(letter);
    }
    Serial.println();
    delay(dash_duration);
  }
  pixels.setPixelColor(0, pixels.Color(255, 0, 0));
  pixels.show();
  delay(space_duration);
  pixels.clear();
  pixels.show();
  delay(space_duration);
}

void output_morse_code(char ch) {
  String characterCode = String(morseCodes[(int)ch - 32]);
  Serial.println(characterCode);
  for (int i = 0; i < characterCode.length(); i++) {
    flash_dot_or_dash(characterCode.charAt(i));
  }
}

void flash_dot_or_dash(char dot_dash) {
  pixels.setPixelColor(0, pixels.Color(255, 255, 255));
  pixels.show();
  if (dot_dash == '.') {
    delay(dot_duration);
  } else { // dash
    delay(dash_duration);
  }
//  pixels.setPixelColor(0, pixels.Color(0, 0, 0));
  pixels.clear();
  pixels.show();
  delay(dot_duration);
}
